!
! eeDaemon                                                                   
! http://eeclust.de                                                          
!                                                                            
! Copyright (c) 2010-2012, University of Hamburg                             
!                                                                            
! See the file COPYING in the package base directory for details             
!                                                                            
! eed_fortran_interface.f90                                             
!                                                                            
!  Created on: Nov 4, 2011                                                      
!      Author: Florian Ehmke                                                 
!

 MODULE EED_F
    INTEGER, PARAMETER :: MODE_UNKOWN = 0
    INTEGER, PARAMETER :: MODE_DEFAULT = 1
    INTEGER, PARAMETER :: MODE_TURBO = 2
    INTEGER, PARAMETER :: MODE_MAX = 3
    INTEGER, PARAMETER :: MODE_MED = 4
    INTEGER, PARAMETER :: MODE_MIN = 5
    INTEGER, PARAMETER :: MODE_UNUSED = 6

    INTERFACE
        SUBROUTINE EE_INIT (NAME, TAG, RANK) BIND(C, NAME='ee_init_fortran')
            USE ISO_C_BINDING
            IMPLICIT NONE
            CHARACTER (kind=c_char) :: NAME(*)
            INTEGER (C_INT), VALUE  :: TAG
            INTEGER (C_INT), VALUE  :: RANK
        END SUBROUTINE EE_INIT
    END INTERFACE

    INTERFACE
        SUBROUTINE EE_INIT_RMS (NAME, RANK) BIND(C, NAME='ee_init_rms_fortran')
            USE ISO_C_BINDING
            IMPLICIT NONE
            CHARACTER (KIND=C_CHAR) :: NAME(*)
            INTEGER (C_INT), VALUE  :: RANK
        END SUBROUTINE EE_INIT_RMS
    END INTERFACE

    INTERFACE
        SUBROUTINE EE_DEV_MODE (DEVICE_ID, MODE_ID) BIND(C, NAME='ee_dev_mode')
            USE ISO_C_BINDING
            IMPLICIT NONE
            INTEGER (C_INT), VALUE  :: DEVICE_ID
            INTEGER (C_INT), VALUE  :: MODE_ID
        END SUBROUTINE EE_DEV_MODE
    END INTERFACE

    INTERFACE
        SUBROUTINE EE_DEV_MODE_IN (DEVICE_ID, MODE_ID, SECS) BIND(C, NAME='ee_dev_mode_in')
            USE ISO_C_BINDING
            IMPLICIT NONE
            INTEGER (C_INT), VALUE  :: DEVICE_ID
            INTEGER (C_INT), VALUE  :: MODE_ID
            INTEGER (C_INT), VALUE  :: SECS
        END SUBROUTINE EE_DEV_MODE_IN
    END INTERFACE

    INTERFACE
        SUBROUTINE EE_FINALIZE () BIND(C, NAME='ee_finalize')
            USE ISO_C_BINDING
            IMPLICIT NONE
        END SUBROUTINE EE_FINALIZE
    END INTERFACE

    INTERFACE
        SUBROUTINE EE_FINALIZE_ALL (TAG) BIND(C, NAME='ee_finalize_all')
            USE ISO_C_BINDING
            IMPLICIT NONE
            INTEGER (C_INT), VALUE  :: TAG
            END SUBROUTINE EE_FINALIZE_ALL
    END INTERFACE
END MODULE EED_F
