/*
 * eeDaemon
 * http://eeclust.de
 *
 * Copyright (c) 2010-2012, University of Hamburg
 *
 * See the file COPYING in the package base directory for details
 *
 * print.c
 *
 *  Created on: Feb 4, 2011
 *  Author: Timo Minartz
 */

#include "print.h"

gchar * getSystemDate()
{

	GTimeVal result;
	g_get_current_time(&result);

	return g_time_val_to_iso8601(&result);
}


#ifdef G_THREADS_ENABLED
gchar * getThreadName(GThread * lookup_thread) {
	if(threads == NULL)
		return NULL;

	return (gchar *) g_hash_table_lookup(threads, lookup_thread);
}

void registerThread(GThread * register_thread, gchar * name) {
	if (threads == NULL)
		threads = g_hash_table_new(g_direct_hash, g_direct_equal);

	if(name == NULL)
		name = "main";

	g_hash_table_insert(threads, register_thread, g_strdup(name));
}
void clearThreads() {
	GHashTableIter iter;
	gpointer key, value;

	g_hash_table_iter_init(&iter, threads);
	while (g_hash_table_iter_next(&iter, &key, &value)) {
		g_free(value);
	}

	g_hash_table_destroy(threads);
}
#endif
