/*
 * eeDaemon
 * http://eeclust.de
 *
 * Copyright (c) 2010-2012, University of Hamburg
 *
 * See the file COPYING in the package base directory for details
 *
 * CientTest.c
 *
 *  Created on: Jul 20, 2011
 *      Author: Timo Minartz
 */

#ifndef CLIENTTEST_C_
#define CLIENTTEST_C_

#include "Client.h"
#include "Command.h"
#include <glib.h>
#include <unistd.h> /* for sleep */

void test_client(void) {

	gint tag = 1313;
	gint rank = 0;
	gint port = 1313;

	// create server socket

	g_type_init();

	GSocketListener * listen = g_socket_listener_new();

	g_socket_listener_add_inet_port(listen, port, NULL, NULL);

	// create client which connect to listener

	Client * client = client_new(port);

	// now create connection on server side

	GSocketConnection * conn = g_socket_listener_accept(listen, NULL, NULL,
			NULL);

	g_assert(conn != NULL);

	GInputStream * stream = g_io_stream_get_input_stream((GIOStream*) conn);

	g_assert(stream != NULL);

	// send command from client

	client_send_command(client, command_new("(sii)", "ee_init", tag, rank));

	Command * command;

	gint ret = command_receive(stream, NULL, &command);

	g_assert_cmpint(ret, ==, TRUE);

	GString * result = g_string_new("ee_init");
	g_string_append_printf(result, "(%d,%d)", tag, rank);

	gchar * string = command_get_string(command);

	g_assert_cmpstr(string, ==, result->str);

	command_unref(command);
	g_free(string);

	g_string_free(result, TRUE);

	client_send_command(client, command_new("(sii)", "ee_finalize", tag, rank));

	ret = command_receive(stream, NULL, &command);

	g_assert_cmpint(ret, ==, TRUE);

	result = g_string_new("ee_finalize");
	g_string_append_printf(result, "(%d,%d)", tag, rank);

	string = command_get_string(command);

	g_assert_cmpstr(string, ==, result->str);

	command_unref(command);
	g_free(string);

	g_string_free(result, TRUE);

	g_object_unref(conn);

	g_socket_listener_close (listen);

	g_object_unref(listen);

	client_unref(client);

}

#endif /* CLIENTTEST_C_ */
