/*
 * eeDaemon
 * http://eeclust.de
 *
 * Copyright (c) 2010-2012, University of Hamburg
 *
 * See the file COPYING in the package base directory for details
 *
 * ClientTestSuite.c
 *
 *  Created on: Aug 6, 2011
 *      Author: Timo Minartz
 */

#include <glib.h>

#include "TestMethods.h"
#include "print.h"
#include "InterfaceTest.h"
#include "ClientTest.h"
#include "RMSTest.h"

gint main(gint argc, gchar ** argv) {

	print_debug_messages = 1;
	verbose = TRUE;

	debug(1, "Activated debug messages on level 1.\n");
	info("Be verbose.\n");

	// initialize test program
	g_test_init(&argc, &argv, NULL);

	set_working_dir(g_get_current_dir());

	// hook up test functions

//	if (is_test_root_context()) {
//	}

	g_test_add_func("/Client/test", test_client);
	g_test_add_func("/Interface/basic", test_interface_basic);
	g_test_add_func("/Interface/rms", test_interface_rms);
//	g_test_add_func("/Interface/application", test_interface_application);

#ifdef HAVE_MPI
	g_test_add_func("/Interface/mpi", test_interface_mpi);
#endif

//	if (is_test_eeclust_node()) {
//	}

	// run tests from the suite
	return g_test_run();

}
