/*
 * eeDaemon
 * http://eeclust.de
 *
 * Copyright (c) 2010-2012, University of Hamburg
 *
 * See the file COPYING in the package base directory for details
 *
 * CoreTest.c
 *
 *  Created on: Jul 6, 2011
 *  Author: Timo Minartz
 */
#include <glib.h>

#include "Core.h"
#include "CoreTest.h"
#include "TestMethods.h"

void test_core_state_switch(void) {

	Core * core = core_new(0);

	g_assert_cmpint(core_get_mode(core), ==, MODE_DEFAULT);

	core_switch_to_mode(core, MODE_MAX);

	g_assert_cmpint(core_get_mode(core), ==, MODE_MAX);

	if(core->has_turboboost)
		g_assert_cmpint(core_get_state(core), ==, core->frequencies[1]);
	else
		g_assert_cmpint(core_get_state(core), ==, core->frequencies[0]);

	if (is_test_intel_node()) {

		g_assert_cmpint(core_get_state(core), ==, 2800000);

	} else if (is_test_amd_node()) {

		g_assert_cmpint(core_get_state(core), ==, 1900000);
	}

	core_switch_to_mode(core, MODE_MED);

	g_assert_cmpint(core_get_mode(core), ==, MODE_MED);

	g_assert_cmpint(core_get_state(core), ==, core->frequencies[core->count_frequencies / 2]);

	if (is_test_intel_node()) {

		g_assert_cmpint(core_get_state(core), ==, 2267000);

	} else if (is_test_amd_node()) {

		g_assert_cmpint(core_get_state(core), ==, 1300000);
	}

	core_switch_to_mode(core, MODE_MIN);

	g_assert_cmpint(core_get_mode(core), ==, MODE_MIN);

	g_assert_cmpint(core_get_state(core), ==, core->frequencies[core->count_frequencies - 1]);

	if (is_test_intel_node()) {

		g_assert_cmpint(core_get_state(core), ==, 1600000);

	} else if (is_test_amd_node()) {

		g_assert_cmpint(core_get_state(core), ==, 800000);
	}

	core_switch_to_mode(core, MODE_UNUSED);

	g_assert_cmpint(core_get_mode(core), ==, MODE_UNUSED);

	g_assert_cmpint(core_get_state(core), ==, core->frequencies[core->count_frequencies - 1]);

	if (is_test_intel_node()) {

		g_assert_cmpint(core_get_state(core), ==, 1600000);

	} else if (is_test_amd_node()) {

		g_assert_cmpint(core_get_state(core), ==, 800000);
	}

	core_switch_to_mode(core, MODE_TURBO);

	g_assert_cmpint(core_get_mode(core), ==, MODE_TURBO);

	if (is_test_intel_node()) {

		g_assert_cmpint(core_get_state(core), ==, 2801000);

	} else if (is_test_amd_node()) {

		g_assert_cmpint(core_get_state(core), ==, 1900000);
	}

	core_unref(core);

	// MODE_DEFAULT again
}
