/*
 * eeDaemon
 * http://eeclust.de
 *
 * Copyright (c) 2010-2012, University of Hamburg
 *
 * See the file COPYING in the package base directory for details
 *
 * TestMethods.c
 *
 *  Created on: Jul 20, 2011
 *  Author: Timo Minartz
 */

#include "TestMethods.h"

#include <unistd.h>		/* needed for getuid()      */
#include <unistd.h>		/* needed for gethostname() */
#include <sched.h> 		/* for sched_getcpu */

static gchar * working_dir;

void set_working_dir(gchar * dir) {
	working_dir = dir;
}

gchar * get_working_dir() {
	return working_dir;
}

gboolean is_test_intel_node() {
	gchar hostname[20];
	gethostname(hostname, 20);

	if (g_str_has_prefix(hostname, "intel"))
		return TRUE;

	return FALSE;
}

gboolean is_test_amd_node() {
	gchar hostname[20];
	gethostname(hostname, 20);

	if (g_str_has_prefix(hostname, "amd"))
		return TRUE;

	return FALSE;
}

gboolean is_test_eeclust_node() {
	return is_test_amd_node() || is_test_intel_node();
}

gboolean is_test_root_context() {
	uid_t uid = getuid();
	return uid == 0;
}

gint pin_process() {
	return pin_process_to_core(0);
}

gint pin_process_to_core(gint id) {
	cpu_set_t *set = CPU_ALLOC(1);

	CPU_ZERO_S(CPU_ALLOC_SIZE(1), set);
	CPU_SET_S(id, CPU_ALLOC_SIZE(1), set);
	sched_setaffinity(id, CPU_ALLOC_SIZE(1),	set);

	CPU_FREE(set);

	gint core_id = sched_getcpu();

	g_assert_cmpint(core_id, ==, id);

	return core_id;
}
